/* USER CODE BEGIN Header */
/* you can remove the copyright */

/*
 *  Copyright 2020-2024 Yuntu Microelectronics co.,ltd
 *  All rights reserved.
 * 
 *  YUNTU Confidential. This software is owned or controlled by YUNTU and may only be
 *  used strictly in accordance with the applicable license terms. By expressly
 *  accepting such terms or by downloading, installing, activating and/or otherwise
 *  using the software, you are agreeing that you have read, and that you agree to
 *  comply with and are bound by, such license terms. If you do not agree to be
 *  bound by the applicable license terms, then you may not retain, install,
 *  activate or otherwise use the software. The production use license in
 *  Section 2.3 is expressly granted for this software.
 * 
 * @file main.c
 * @brief 
 * 
 */

/* USER CODE END Header */
#include "sdk_project_config.h"
/* Includes ------------------------------------------------------------------*/

/* Private includes ----------------------------------------------------------*/
/* USER CODE BEGIN Includes */
/* USER CODE END Includes */

/* Private typedef -----------------------------------------------------------*/
/* USER CODE BEGIN PTD */
/* USER CODE END PTD */

/* Private define ------------------------------------------------------------*/
/* USER CODE BEGIN PD */
/* USER CODE END PD */

/* Private macro -------------------------------------------------------------*/
/* USER CODE BEGIN PM */
#define UART_INSTANCE           (0)
#define UART_TX_LENGTH          (2)
#define UART_BREAK_LENGTH       (2)
/* USER CODE END PM */

/* Private variables ---------------------------------------------------------*/
/* USER CODE BEGIN PV */
uint8_t g_uartTxBuffer[] = {0x30, 0x31 };
uint8_t g_uartRxBuffer[UART_TX_LENGTH] = {0};
uint32_t g_bytesRemaining;
/* USER CODE END PV */

/* Private function declare --------------------------------------------------*/
/* USER CODE BEGIN PFDC */
/* USER CODE END PFDC */
static void Board_Init(void);

/* Private user code ---------------------------------------------------------*/
/* USER CODE BEGIN 0 */
/* USER CODE END 0 */


/**
 * @brief  The application entry point.
 * @retval int
 */
int main(void)
{
    /* USER CODE BEGIN 1 */
    /* USER CODE END 1 */ 
    Board_Init();
    /* USER CODE BEGIN 2 */
#if 0
    UART_DRV_SendData(UART_INSTANCE, g_uartTxBuffer, UART_TX_LENGTH);
    /* Waiting for transmission to complete */
    while (UART_DRV_GetTransmitStatus(UART_INSTANCE, &g_bytesRemaining)){}
    
    UART0->DATA = UART_DATA_LINBRK(1);
    UART_DRV_SendData(UART_INSTANCE, g_uartTxBuffer, UART_BREAK_LENGTH);
    while (UART_DRV_GetTransmitStatus(UART_INSTANCE, &g_bytesRemaining)){}
#endif

    UART_DRV_SendData(UART_INSTANCE, g_uartTxBuffer, UART_TX_LENGTH);
    /* Waiting for transmission to complete */
    while (UART_DRV_GetTransmitStatus(UART_INSTANCE, &g_bytesRemaining)){}
    
    UART0->CTRL1 |= UART_CTRL1_SBK(1);
    UART_DRV_SendData(UART_INSTANCE, g_uartTxBuffer, UART_BREAK_LENGTH);

    OSIF_TimeDelay(1);

    UART0->CTRL1 &= (~UART_CTRL1_SBK(1));
    while (UART_DRV_GetTransmitStatus(UART_INSTANCE, &g_bytesRemaining)){}
    /* USER CODE END 2 */

    /* Infinite loop */
    /* USER CODE BEGIN WHILE */
    while (1)
    {
        /* USER CODE END WHILE */
        /* USER CODE BEGIN 3 */
    }
    /* USER CODE END 3 */
}

static void Board_Init(void)
{
    CLOCK_SYS_Init(g_clockManConfigsArr,CLOCK_MANAGER_CONFIG_CNT,g_clockManCallbacksArr,CLOCK_MANAGER_CALLBACK_CNT);
    CLOCK_SYS_UpdateConfiguration(CLOCK_MANAGER_ACTIVE_INDEX,CLOCK_MANAGER_POLICY_AGREEMENT);
    PINS_DRV_Init(NUM_OF_CONFIGURED_PINS0,g_pin_mux_InitConfigArr0);
    UART_DRV_Init(0,&uart_config0_State,&uart_config0);
}

/* USER CODE BEGIN 4 */
/* USER CODE END 4 */
